
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 05/20/2013 19:17:28
-- Generated from EDMX file: C:\eXpandFrameWork\Samples\DXSK8\DXSK8.Service\SK8Data.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [DXSK8];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_ProductProductType]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Products] DROP CONSTRAINT [FK_ProductProductType];
GO
IF OBJECT_ID(N'[dbo].[FK_BrandProduct]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Products] DROP CONSTRAINT [FK_BrandProduct];
GO
IF OBJECT_ID(N'[dbo].[FK_ProductInventory]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Inventorys] DROP CONSTRAINT [FK_ProductInventory];
GO
IF OBJECT_ID(N'[dbo].[FK_StoreInventory]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Inventorys] DROP CONSTRAINT [FK_StoreInventory];
GO
IF OBJECT_ID(N'[dbo].[FK_ProductFlavorProduct]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Products] DROP CONSTRAINT [FK_ProductFlavorProduct];
GO
IF OBJECT_ID(N'[dbo].[FK_OrderOrderItem]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[OrderItems] DROP CONSTRAINT [FK_OrderOrderItem];
GO
IF OBJECT_ID(N'[dbo].[FK_OrderItemProduct]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[OrderItems] DROP CONSTRAINT [FK_OrderItemProduct];
GO
IF OBJECT_ID(N'[dbo].[FK_EmployeeOrder]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Orders] DROP CONSTRAINT [FK_EmployeeOrder];
GO
IF OBJECT_ID(N'[dbo].[FK_CustomerOrder]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Orders] DROP CONSTRAINT [FK_CustomerOrder];
GO
IF OBJECT_ID(N'[dbo].[FK_ProductImages]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Products] DROP CONSTRAINT [FK_ProductImages];
GO
IF OBJECT_ID(N'[dbo].[FK_LoginImages]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Logins] DROP CONSTRAINT [FK_LoginImages];
GO
IF OBJECT_ID(N'[dbo].[FK_BrandImageSource]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Brands] DROP CONSTRAINT [FK_BrandImageSource];
GO
IF OBJECT_ID(N'[dbo].[FK_Roles_Roles_Role]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Roles_Roles] DROP CONSTRAINT [FK_Roles_Roles_Role];
GO
IF OBJECT_ID(N'[dbo].[FK_Roles_Roles_Role1]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Roles_Roles] DROP CONSTRAINT [FK_Roles_Roles_Role1];
GO
IF OBJECT_ID(N'[dbo].[FK_RoleTypePermissionObject]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[TypePermissionObjects] DROP CONSTRAINT [FK_RoleTypePermissionObject];
GO
IF OBJECT_ID(N'[dbo].[FK_EmployeeRole_Employee]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[EmployeeRole] DROP CONSTRAINT [FK_EmployeeRole_Employee];
GO
IF OBJECT_ID(N'[dbo].[FK_EmployeeRole_Role]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[EmployeeRole] DROP CONSTRAINT [FK_EmployeeRole_Role];
GO
IF OBJECT_ID(N'[dbo].[FK_Employee_inherits_Login]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Logins_Employee] DROP CONSTRAINT [FK_Employee_inherits_Login];
GO
IF OBJECT_ID(N'[dbo].[FK_Customer_inherits_Login]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Logins_Customer] DROP CONSTRAINT [FK_Customer_inherits_Login];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[Brands]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Brands];
GO
IF OBJECT_ID(N'[dbo].[Products]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Products];
GO
IF OBJECT_ID(N'[dbo].[ProductTypes]', 'U') IS NOT NULL
    DROP TABLE [dbo].[ProductTypes];
GO
IF OBJECT_ID(N'[dbo].[Stores]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Stores];
GO
IF OBJECT_ID(N'[dbo].[Inventorys]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Inventorys];
GO
IF OBJECT_ID(N'[dbo].[ProductFlavors]', 'U') IS NOT NULL
    DROP TABLE [dbo].[ProductFlavors];
GO
IF OBJECT_ID(N'[dbo].[Orders]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Orders];
GO
IF OBJECT_ID(N'[dbo].[OrderItems]', 'U') IS NOT NULL
    DROP TABLE [dbo].[OrderItems];
GO
IF OBJECT_ID(N'[dbo].[Logins]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Logins];
GO
IF OBJECT_ID(N'[dbo].[ImageSources]', 'U') IS NOT NULL
    DROP TABLE [dbo].[ImageSources];
GO
IF OBJECT_ID(N'[dbo].[NotificationChannels]', 'U') IS NOT NULL
    DROP TABLE [dbo].[NotificationChannels];
GO
IF OBJECT_ID(N'[dbo].[Roles]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Roles];
GO
IF OBJECT_ID(N'[dbo].[TypePermissionObjects]', 'U') IS NOT NULL
    DROP TABLE [dbo].[TypePermissionObjects];
GO
IF OBJECT_ID(N'[dbo].[Logins_Employee]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Logins_Employee];
GO
IF OBJECT_ID(N'[dbo].[Logins_Customer]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Logins_Customer];
GO
IF OBJECT_ID(N'[dbo].[Roles_Roles]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Roles_Roles];
GO
IF OBJECT_ID(N'[dbo].[EmployeeRole]', 'U') IS NOT NULL
    DROP TABLE [dbo].[EmployeeRole];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'Brands'
CREATE TABLE [dbo].[Brands] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(100)  NOT NULL,
    [ImageUrl] nvarchar(max)  NOT NULL,
    [Logo_Id] int  NOT NULL
);
GO

-- Creating table 'Products'
CREATE TABLE [dbo].[Products] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(100)  NOT NULL,
    [Description] nvarchar(max)  NOT NULL,
    [Price] decimal(18,0)  NOT NULL,
    [ImageUrl] nvarchar(max)  NOT NULL,
    [Type_Id] int  NOT NULL,
    [Brand_Id] int  NOT NULL,
    [Flavor_Id] int  NOT NULL,
    [Image_Id] int  NOT NULL
);
GO

-- Creating table 'ProductTypes'
CREATE TABLE [dbo].[ProductTypes] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(100)  NOT NULL
);
GO

-- Creating table 'Stores'
CREATE TABLE [dbo].[Stores] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Address_Address1] nvarchar(200)  NOT NULL,
    [Address_Address2] nvarchar(200)  NULL,
    [Address_City] nvarchar(100)  NOT NULL,
    [Address_StateProvince] nvarchar(100)  NOT NULL,
    [Address_Postcode] nvarchar(20)  NOT NULL,
    [Notes] nvarchar(max)  NOT NULL,
    [Email] nvarchar(max)  NOT NULL,
    [Phones] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'Inventorys'
CREATE TABLE [dbo].[Inventorys] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Quantity] int  NOT NULL,
    [Product_Id] int  NOT NULL,
    [Store_Id] int  NOT NULL
);
GO

-- Creating table 'ProductFlavors'
CREATE TABLE [dbo].[ProductFlavors] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(100)  NOT NULL
);
GO

-- Creating table 'Orders'
CREATE TABLE [dbo].[Orders] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [OrderDate] datetime  NOT NULL,
    [State] int  NOT NULL,
    [Employee_Id] int  NULL,
    [Customer_Id] int  NOT NULL
);
GO

-- Creating table 'OrderItems'
CREATE TABLE [dbo].[OrderItems] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Quantity] int  NOT NULL,
    [State] int  NOT NULL,
    [Order_Id] int  NOT NULL,
    [Product_Id] int  NOT NULL
);
GO

-- Creating table 'Logins'
CREATE TABLE [dbo].[Logins] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [UserName] nvarchar(max)  NOT NULL,
    [Person_FirstName] nvarchar(max)  NOT NULL,
    [Person_LastName] nvarchar(max)  NOT NULL,
    [Person_Email] nvarchar(max)  NOT NULL,
    [Avatar_Id] int  NOT NULL
);
GO

-- Creating table 'ImageSources'
CREATE TABLE [dbo].[ImageSources] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Image] varbinary(max)  NOT NULL
);
GO

-- Creating table 'NotificationChannels'
CREATE TABLE [dbo].[NotificationChannels] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [ClientId] nvarchar(max)  NOT NULL,
    [Url] nvarchar(max)  NOT NULL,
    [UpdatedOn] datetime  NOT NULL
);
GO

-- Creating table 'Roles'
CREATE TABLE [dbo].[Roles] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NULL,
    [IsAdministrative] bit  NOT NULL,
    [CanEditModel] bit  NOT NULL
);
GO

-- Creating table 'TypePermissionObjects'
CREATE TABLE [dbo].[TypePermissionObjects] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [AllowRead] bit  NOT NULL,
    [AllowWrite] bit  NOT NULL,
    [AllowCreate] bit  NOT NULL,
    [AllowDelete] bit  NOT NULL,
    [AllowNavigate] bit  NOT NULL,
    [TargetTypeFullName] nvarchar(max)  NOT NULL,
    [RoleID] int  NOT NULL
);
GO

-- Creating table 'Logins_Employee'
CREATE TABLE [dbo].[Logins_Employee] (
    [Position] nvarchar(max)  NOT NULL,
    [IsActive] bit  NULL,
    [ChangePasswordOnFirstLogon] bit  NULL,
    [StoredPassword] nvarchar(max)  NULL,
    [Id] int  NOT NULL
);
GO

-- Creating table 'Logins_Customer'
CREATE TABLE [dbo].[Logins_Customer] (
    [IsInStore] bit  NOT NULL,
    [Id] int  NOT NULL
);
GO

-- Creating table 'Roles_Roles'
CREATE TABLE [dbo].[Roles_Roles] (
    [ParentRoles_ID] int  NOT NULL,
    [ChildRoles_ID] int  NOT NULL
);
GO

-- Creating table 'EmployeeRole'
CREATE TABLE [dbo].[EmployeeRole] (
    [Employees_Id] int  NOT NULL,
    [Roles_ID] int  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [Id] in table 'Brands'
ALTER TABLE [dbo].[Brands]
ADD CONSTRAINT [PK_Brands]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Products'
ALTER TABLE [dbo].[Products]
ADD CONSTRAINT [PK_Products]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'ProductTypes'
ALTER TABLE [dbo].[ProductTypes]
ADD CONSTRAINT [PK_ProductTypes]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Stores'
ALTER TABLE [dbo].[Stores]
ADD CONSTRAINT [PK_Stores]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Inventorys'
ALTER TABLE [dbo].[Inventorys]
ADD CONSTRAINT [PK_Inventorys]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'ProductFlavors'
ALTER TABLE [dbo].[ProductFlavors]
ADD CONSTRAINT [PK_ProductFlavors]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Orders'
ALTER TABLE [dbo].[Orders]
ADD CONSTRAINT [PK_Orders]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'OrderItems'
ALTER TABLE [dbo].[OrderItems]
ADD CONSTRAINT [PK_OrderItems]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Logins'
ALTER TABLE [dbo].[Logins]
ADD CONSTRAINT [PK_Logins]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'ImageSources'
ALTER TABLE [dbo].[ImageSources]
ADD CONSTRAINT [PK_ImageSources]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'NotificationChannels'
ALTER TABLE [dbo].[NotificationChannels]
ADD CONSTRAINT [PK_NotificationChannels]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [ID] in table 'Roles'
ALTER TABLE [dbo].[Roles]
ADD CONSTRAINT [PK_Roles]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'TypePermissionObjects'
ALTER TABLE [dbo].[TypePermissionObjects]
ADD CONSTRAINT [PK_TypePermissionObjects]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [Id] in table 'Logins_Employee'
ALTER TABLE [dbo].[Logins_Employee]
ADD CONSTRAINT [PK_Logins_Employee]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Logins_Customer'
ALTER TABLE [dbo].[Logins_Customer]
ADD CONSTRAINT [PK_Logins_Customer]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [ParentRoles_ID], [ChildRoles_ID] in table 'Roles_Roles'
ALTER TABLE [dbo].[Roles_Roles]
ADD CONSTRAINT [PK_Roles_Roles]
    PRIMARY KEY NONCLUSTERED ([ParentRoles_ID], [ChildRoles_ID] ASC);
GO

-- Creating primary key on [Employees_Id], [Roles_ID] in table 'EmployeeRole'
ALTER TABLE [dbo].[EmployeeRole]
ADD CONSTRAINT [PK_EmployeeRole]
    PRIMARY KEY NONCLUSTERED ([Employees_Id], [Roles_ID] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [Type_Id] in table 'Products'
ALTER TABLE [dbo].[Products]
ADD CONSTRAINT [FK_ProductProductType]
    FOREIGN KEY ([Type_Id])
    REFERENCES [dbo].[ProductTypes]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ProductProductType'
CREATE INDEX [IX_FK_ProductProductType]
ON [dbo].[Products]
    ([Type_Id]);
GO

-- Creating foreign key on [Brand_Id] in table 'Products'
ALTER TABLE [dbo].[Products]
ADD CONSTRAINT [FK_BrandProduct]
    FOREIGN KEY ([Brand_Id])
    REFERENCES [dbo].[Brands]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_BrandProduct'
CREATE INDEX [IX_FK_BrandProduct]
ON [dbo].[Products]
    ([Brand_Id]);
GO

-- Creating foreign key on [Product_Id] in table 'Inventorys'
ALTER TABLE [dbo].[Inventorys]
ADD CONSTRAINT [FK_ProductInventory]
    FOREIGN KEY ([Product_Id])
    REFERENCES [dbo].[Products]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ProductInventory'
CREATE INDEX [IX_FK_ProductInventory]
ON [dbo].[Inventorys]
    ([Product_Id]);
GO

-- Creating foreign key on [Store_Id] in table 'Inventorys'
ALTER TABLE [dbo].[Inventorys]
ADD CONSTRAINT [FK_StoreInventory]
    FOREIGN KEY ([Store_Id])
    REFERENCES [dbo].[Stores]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_StoreInventory'
CREATE INDEX [IX_FK_StoreInventory]
ON [dbo].[Inventorys]
    ([Store_Id]);
GO

-- Creating foreign key on [Flavor_Id] in table 'Products'
ALTER TABLE [dbo].[Products]
ADD CONSTRAINT [FK_ProductFlavorProduct]
    FOREIGN KEY ([Flavor_Id])
    REFERENCES [dbo].[ProductFlavors]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ProductFlavorProduct'
CREATE INDEX [IX_FK_ProductFlavorProduct]
ON [dbo].[Products]
    ([Flavor_Id]);
GO

-- Creating foreign key on [Order_Id] in table 'OrderItems'
ALTER TABLE [dbo].[OrderItems]
ADD CONSTRAINT [FK_OrderOrderItem]
    FOREIGN KEY ([Order_Id])
    REFERENCES [dbo].[Orders]
        ([Id])
    ON DELETE CASCADE ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_OrderOrderItem'
CREATE INDEX [IX_FK_OrderOrderItem]
ON [dbo].[OrderItems]
    ([Order_Id]);
GO

-- Creating foreign key on [Product_Id] in table 'OrderItems'
ALTER TABLE [dbo].[OrderItems]
ADD CONSTRAINT [FK_OrderItemProduct]
    FOREIGN KEY ([Product_Id])
    REFERENCES [dbo].[Products]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_OrderItemProduct'
CREATE INDEX [IX_FK_OrderItemProduct]
ON [dbo].[OrderItems]
    ([Product_Id]);
GO

-- Creating foreign key on [Employee_Id] in table 'Orders'
ALTER TABLE [dbo].[Orders]
ADD CONSTRAINT [FK_EmployeeOrder]
    FOREIGN KEY ([Employee_Id])
    REFERENCES [dbo].[Logins_Employee]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_EmployeeOrder'
CREATE INDEX [IX_FK_EmployeeOrder]
ON [dbo].[Orders]
    ([Employee_Id]);
GO

-- Creating foreign key on [Customer_Id] in table 'Orders'
ALTER TABLE [dbo].[Orders]
ADD CONSTRAINT [FK_CustomerOrder]
    FOREIGN KEY ([Customer_Id])
    REFERENCES [dbo].[Logins_Customer]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_CustomerOrder'
CREATE INDEX [IX_FK_CustomerOrder]
ON [dbo].[Orders]
    ([Customer_Id]);
GO

-- Creating foreign key on [Image_Id] in table 'Products'
ALTER TABLE [dbo].[Products]
ADD CONSTRAINT [FK_ProductImages]
    FOREIGN KEY ([Image_Id])
    REFERENCES [dbo].[ImageSources]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ProductImages'
CREATE INDEX [IX_FK_ProductImages]
ON [dbo].[Products]
    ([Image_Id]);
GO

-- Creating foreign key on [Avatar_Id] in table 'Logins'
ALTER TABLE [dbo].[Logins]
ADD CONSTRAINT [FK_LoginImages]
    FOREIGN KEY ([Avatar_Id])
    REFERENCES [dbo].[ImageSources]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_LoginImages'
CREATE INDEX [IX_FK_LoginImages]
ON [dbo].[Logins]
    ([Avatar_Id]);
GO

-- Creating foreign key on [Logo_Id] in table 'Brands'
ALTER TABLE [dbo].[Brands]
ADD CONSTRAINT [FK_BrandImageSource]
    FOREIGN KEY ([Logo_Id])
    REFERENCES [dbo].[ImageSources]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_BrandImageSource'
CREATE INDEX [IX_FK_BrandImageSource]
ON [dbo].[Brands]
    ([Logo_Id]);
GO

-- Creating foreign key on [ParentRoles_ID] in table 'Roles_Roles'
ALTER TABLE [dbo].[Roles_Roles]
ADD CONSTRAINT [FK_Roles_Roles_Role]
    FOREIGN KEY ([ParentRoles_ID])
    REFERENCES [dbo].[Roles]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating foreign key on [ChildRoles_ID] in table 'Roles_Roles'
ALTER TABLE [dbo].[Roles_Roles]
ADD CONSTRAINT [FK_Roles_Roles_Role1]
    FOREIGN KEY ([ChildRoles_ID])
    REFERENCES [dbo].[Roles]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_Roles_Roles_Role1'
CREATE INDEX [IX_FK_Roles_Roles_Role1]
ON [dbo].[Roles_Roles]
    ([ChildRoles_ID]);
GO

-- Creating foreign key on [RoleID] in table 'TypePermissionObjects'
ALTER TABLE [dbo].[TypePermissionObjects]
ADD CONSTRAINT [FK_RoleTypePermissionObject]
    FOREIGN KEY ([RoleID])
    REFERENCES [dbo].[Roles]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_RoleTypePermissionObject'
CREATE INDEX [IX_FK_RoleTypePermissionObject]
ON [dbo].[TypePermissionObjects]
    ([RoleID]);
GO

-- Creating foreign key on [Employees_Id] in table 'EmployeeRole'
ALTER TABLE [dbo].[EmployeeRole]
ADD CONSTRAINT [FK_EmployeeRole_Employee]
    FOREIGN KEY ([Employees_Id])
    REFERENCES [dbo].[Logins_Employee]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating foreign key on [Roles_ID] in table 'EmployeeRole'
ALTER TABLE [dbo].[EmployeeRole]
ADD CONSTRAINT [FK_EmployeeRole_Role]
    FOREIGN KEY ([Roles_ID])
    REFERENCES [dbo].[Roles]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_EmployeeRole_Role'
CREATE INDEX [IX_FK_EmployeeRole_Role]
ON [dbo].[EmployeeRole]
    ([Roles_ID]);
GO

-- Creating foreign key on [Id] in table 'Logins_Employee'
ALTER TABLE [dbo].[Logins_Employee]
ADD CONSTRAINT [FK_Employee_inherits_Login]
    FOREIGN KEY ([Id])
    REFERENCES [dbo].[Logins]
        ([Id])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- Creating foreign key on [Id] in table 'Logins_Customer'
ALTER TABLE [dbo].[Logins_Customer]
ADD CONSTRAINT [FK_Customer_inherits_Login]
    FOREIGN KEY ([Id])
    REFERENCES [dbo].[Logins]
        ([Id])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------